'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _AutoComplete = require('material-ui/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyAutoComplete is a wrapper around Material UI's [AutoComplete](http://www.material-ui.com/#/components/auto-complete) component.
 * 
 * @deprecated The AutoComplete component is [not](https://github.com/callemall/material-ui/pull/7477) being ported to Material UI v1.
 * As such this component is now being deprecated and will be completely removed when Material UI v1 is released.
 */
var FormsyAutoComplete = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyAutoComplete, _Formsy$Mixin);

  function FormsyAutoComplete(props) {
    (0, _classCallCheck3.default)(this, FormsyAutoComplete);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyAutoComplete.__proto__ || (0, _getPrototypeOf2.default)(FormsyAutoComplete)).call(this, props));

    _this.state = (0, _assign2.default)(_this.state, {
      _value: props.searchText,
      _pristineValue: props.searchText
    });

    // eslint-disable-next-line no-console
    console.warn('FormsyAutoComplete is deprecated and will be compeletely removed in a future release.  Consider switching to a different component.');
    return _this;
  }

  (0, _createClass3.default)(FormsyAutoComplete, [{
    key: 'handleBlur',
    value: function handleBlur(event) {
      this.setValue(event.target.value);
    }
  }, {
    key: 'handleUpdateInput',
    value: function handleUpdateInput(value, dataSource, params) {
      this.setValue(value);
      if (this.props.onUpdateInput) this.props.onUpdateInput(value, dataSource, params);
      if (this.props.onChange) this.props.onChange(value, -1);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(event) {
      if ((0, _keycode2.default)(event) === 'enter') this.setValue(event.target.value);
      if (this.props.onKeyDown) this.props.onKeyDown(event);
    }
  }, {
    key: 'handleNewRequest',
    value: function handleNewRequest(value, index) {
      this.setValue(value);
      if (this.props.onNewRequest) this.props.onNewRequest(value, index);
      if (this.props.onChange) this.props.onChange(value, index);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          onUpdateInput = _removeFormsyProps.onUpdateInput,
          searchText = _removeFormsyProps.searchText,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['onUpdateInput', 'searchText']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      return _react2.default.createElement(_AutoComplete2.default, (0, _extends3.default)({}, props, {
        errorText: this.getErrorMessage(),
        onBlur: function onBlur(e) {
          _this2.handleBlur(e);
        },
        onUpdateInput: function onUpdateInput(v, d, p) {
          _this2.handleUpdateInput(v, d, p);
        },
        onKeyDown: function onKeyDown(e) {
          _this2.handleKeyDown(e);
        },
        onNewRequest: function onNewRequest(v, i) {
          _this2.handleNewRequest(v, i);
        },
        searchText: this.getValue()
      }));
    }
  }]);
  return FormsyAutoComplete;
}(_formsyReact2.default.Mixin);

FormsyAutoComplete.propTypes = {
  /**
   * Call back function that is fired when the value AutoComplete component changes.
   * @type {[type]}
   * @param {String} value The AutoComplete `searchText` value.
   * @param {Number} index The index in `dataSource` of the list item selected, or -1 otherwise.
   */
  onChange: _propTypes2.default.func
};

exports.default = FormsyAutoComplete;