'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyCheckbox is a wrapper around Material UI's [Checkbox](http://www.material-ui.com/#/components/checkbox) component.
 */
var FormsyCheckbox = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyCheckbox, _Formsy$Mixin);

  function FormsyCheckbox(props) {
    (0, _classCallCheck3.default)(this, FormsyCheckbox);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyCheckbox.__proto__ || (0, _getPrototypeOf2.default)(FormsyCheckbox)).call(this, props));

    var checked = props.checked,
        defaultChecked = props.defaultChecked;

    var isChecked = checked || defaultChecked || false;

    _this.state = (0, _assign2.default)(_this.state, {
      _value: isChecked,
      _pristineValue: isChecked
    });
    return _this;
  }

  (0, _createClass3.default)(FormsyCheckbox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _get3.default)(FormsyCheckbox.prototype.__proto__ || (0, _getPrototypeOf2.default)(FormsyCheckbox.prototype), 'componentWillReceiveProps', this).call(this, nextProps);
      if (this.props.checked !== nextProps.checked) {
        this.setValue(nextProps.checked);
      }
    }
  }, {
    key: 'handleCheck',
    value: function handleCheck(event, value) {
      this.setValue(value);
      if (this.props.onChange) this.props.onChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          checked = _removeFormsyProps.checked,
          defaultChecked = _removeFormsyProps.defaultChecked,
          onCheck = _removeFormsyProps.onCheck,
          onChange = _removeFormsyProps.onChange,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['checked', 'defaultChecked', 'onCheck', 'onChange']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      var value = this.getValue();

      return _react2.default.createElement(_Checkbox2.default, (0, _extends3.default)({}, props, {
        checked: value,
        onCheck: function onCheck(e, v) {
          _this2.handleCheck(e, v);
        }
      }));
    }
  }]);
  return FormsyCheckbox;
}(_formsyReact2.default.Mixin);

FormsyCheckbox.propTypes = {
  /**
   * Checkbox is checked if true.
   * @type {[type]}
   */
  checked: _propTypes2.default.bool,

  /**
   * The default state of the checkbox component.
   * **Warning:** This cannot be used in conjunction with `checked`.
   * Decide between using a controlled or uncontrolled input element and remove one of these props.
   * More info: https://fb.me/react-controlled-components
   * @type {[type]}
   */
  defaultChecked: _propTypes2.default.bool,

  /**
   * Callback function that is fired when the checkbox is checked.
   * @type {[type]}
   * @param {Object} event `change` event targeting the underlying checkbox `input`.
   * @param {Boolean} value The `checked` value of the underlying checkbox `input`.
   */
  onChange: _propTypes2.default.func
};

exports.default = FormsyCheckbox;