'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _RadioButtonGroup = require('material-ui/RadioButton/RadioButtonGroup');

var _RadioButtonGroup2 = _interopRequireDefault(_RadioButtonGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyDate is a wrapper around Material UI's [Radio Button Group](http://www.material-ui.com/#/components/radio-button) component.
 */
var FormsyRadioGroup = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyRadioGroup, _Formsy$Mixin);

  function FormsyRadioGroup(props) {
    (0, _classCallCheck3.default)(this, FormsyRadioGroup);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyRadioGroup.__proto__ || (0, _getPrototypeOf2.default)(FormsyRadioGroup)).call(this, props));

    var selected = 'valueSelected' in props ? props.valueSelected : props.defaultSelected;

    _this.state = (0, _assign2.default)(_this.state, {
      _value: selected,
      _pristineValue: selected
    });
    return _this;
  }

  (0, _createClass3.default)(FormsyRadioGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _get3.default)(FormsyRadioGroup.prototype.__proto__ || (0, _getPrototypeOf2.default)(FormsyRadioGroup.prototype), 'componentWillReceiveProps', this).call(this, nextProps);
      if (this.props.valueSelected !== nextProps.valueSelected) {
        this.setValue(nextProps.valueSelected);
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event, value) {
      this.setValue(value);
      if (this.props.onChange) this.props.onChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          valueSelected = _removeFormsyProps.valueSelected,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['valueSelected']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      return _react2.default.createElement(
        _RadioButtonGroup2.default,
        (0, _extends3.default)({}, props, {
          valueSelected: this.getValue(),
          onChange: function onChange(e, v) {
            _this2.handleChange(e, v);
          } }),
        this.props.children
      );
    }
  }]);
  return FormsyRadioGroup;
}(_formsyReact2.default.Mixin);

FormsyRadioGroup.propTypes = {
  /**
   * The value property of the radio button that will be selected by default.
   * This takes precedence over the checked property of the RadioButton elements.
   * @type {[type]}
   */
  defaultSelected: _propTypes2.default.any,

  /**
   * Callback function that is fired when a radio button has been checked.
   * @type {[type]}
   * @param {Object} event `change` event targeting the selected radio button.
   * @param {Boolean} value The `value` of the selected radio button.
   */
  onChange: _propTypes2.default.func,

  /**
   * The value of the currently selected radio button.
   * @type {[type]}
   */
  valueSelected: _propTypes2.default.any
};

exports.default = FormsyRadioGroup;