'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsySelect is a wrapper around Material UI's [Select Field](http://www.material-ui.com/#/components/select-field) component.
 */
var FormsySelect = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsySelect, _Formsy$Mixin);

  function FormsySelect() {
    (0, _classCallCheck3.default)(this, FormsySelect);
    return (0, _possibleConstructorReturn3.default)(this, (FormsySelect.__proto__ || (0, _getPrototypeOf2.default)(FormsySelect)).apply(this, arguments));
  }

  (0, _createClass3.default)(FormsySelect, [{
    key: 'handleChange',
    value: function handleChange(event, key, value) {
      this.setValue(value);
      if (this.props.onChange) this.props.onChange(event, key, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          onChange = _removeFormsyProps.onChange,
          value = _removeFormsyProps.value,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['onChange', 'value']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      return _react2.default.createElement(
        _SelectField2.default,
        (0, _extends3.default)({}, props, {
          errorText: this.getErrorMessage(),
          onChange: function onChange(e, k, v) {
            _this2.handleChange(e, k, v);
          },
          value: this.getValue() }),
        this.props.children
      );
    }
  }]);
  return FormsySelect;
}(_formsyReact2.default.Mixin);

FormsySelect.propTypes = {
  /**
   * @ignore
   */
  children: _propTypes2.default.node,

  /**
   * Callback function fired when a menu item is selected.
   * @type {[type]}
   * @param {Object} event Change event targeting the menu item that was selected.
   * @param {Number} key The index of the selected menu item, or undefined if `multiple`` is true.
   * @param {Boolean} value If multiple is true, the menu's value array with either
   *                        the menu item's value added (if it wasn't already selected) or omitted
   *                        (if it was already selected). Otherwise, the value of the menu item.
   */
  onChange: _propTypes2.default.func,

  /**
   * If multiple is true, an array of the values of the selected menu items. Otherwise, the value
   * of the selected menu item. If provided, the menu will be a controlled component.
   * @type {[type]}
   */
  value: _propTypes2.default.any
};

exports.default = FormsySelect;