'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _formsyReact = require('formsy-react-2');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _Toggle = require('material-ui/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormsyToggle is a wrapper around Material UI's [Toggle](http://www.material-ui.com/#/components/toggle) component.
 */
var FormsyToggle = function (_Formsy$Mixin) {
  (0, _inherits3.default)(FormsyToggle, _Formsy$Mixin);

  function FormsyToggle(props) {
    (0, _classCallCheck3.default)(this, FormsyToggle);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormsyToggle.__proto__ || (0, _getPrototypeOf2.default)(FormsyToggle)).call(this, props));

    var toggled = props.toggled,
        defaultToggled = props.defaultToggled;

    var isToggled = toggled || defaultToggled || false;

    _this.state = (0, _assign2.default)(_this.state, {
      _value: isToggled,
      _pristineValue: isToggled
    });
    return _this;
  }

  (0, _createClass3.default)(FormsyToggle, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _get3.default)(FormsyToggle.prototype.__proto__ || (0, _getPrototypeOf2.default)(FormsyToggle.prototype), 'componentWillReceiveProps', this).call(this, nextProps);
      if (this.props.toggled !== nextProps.toggled) {
        this.setValue(nextProps.toggled);
      }
    }
  }, {
    key: 'handleToggle',
    value: function handleToggle(event, value) {
      this.setValue(value);
      if (this.props.onChange) this.props.onChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _removeFormsyProps = this.removeFormsyProps(this.props),
          toggled = _removeFormsyProps.toggled,
          defaultToggled = _removeFormsyProps.defaultToggled,
          onToggle = _removeFormsyProps.onToggle,
          onChange = _removeFormsyProps.onChange,
          rest = (0, _objectWithoutProperties3.default)(_removeFormsyProps, ['toggled', 'defaultToggled', 'onToggle', 'onChange']);

      var props = (0, _assign2.default)({ disabled: this.isFormDisabled() }, rest);

      return _react2.default.createElement(_Toggle2.default, (0, _extends3.default)({}, props, {
        toggled: this.getValue(),
        onToggle: function onToggle(e, v) {
          _this2.handleToggle(e, v);
        }
      }));
    }
  }]);
  return FormsyToggle;
}(_formsyReact2.default.Mixin);

FormsyToggle.propTypes = {
  /**
   * The default state of the toggle component.
   * **Warning:** This cannot be used in conjunction with `toggled`.
   * Decide between using a controlled or uncontrolled input element and remove one of these props.
   * More info: https://fb.me/react-controlled-components
   * @type {[type]}
   */
  defaultToggled: _propTypes2.default.bool,

  /**
   * Callback function that is fired when the toggle is toggled.
   * @type {[type]}
   * @param {Object} event `change` event targeting the underlying toggle `input`.
   * @param {Boolean} value The `toggled` value of the underlying toggle `input`.
   */
  onChange: _propTypes2.default.func,

  /**
   * Toggle is toggled if true.
   * @type {[type]}
   */
  toggled: _propTypes2.default.bool
};

exports.default = FormsyToggle;